package hu.bme.mit.socialnetwork.gui.handlers;
import hu.bme.mit.socialnetwork.gui.ListView;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.IHandler;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.handlers.HandlerUtil;

import socialnetwork.SocialNetwork;

public class OpenView extends AbstractHandler implements IHandler {

	@Override
	public Object execute(ExecutionEvent event) throws ExecutionException {
		try {
			ISelection selection = HandlerUtil.getCurrentSelection(event);
			Object _sel = ((IStructuredSelection)selection).getFirstElement();
			if (!(_sel instanceof SocialNetwork)) return null;
			
			IViewPart part = PlatformUI.getWorkbench()
					.getActiveWorkbenchWindow().getActivePage()
					.showView("hu.bme.mit.socialnetwork.gui.networkview");
			ListView view = (ListView) part;
			view.setNetwork((SocialNetwork) _sel);
		} catch (PartInitException e) {
			throw new ExecutionException("Cannot open view", e);
		}
		return null;
	}

}
