package hu.bme.mit.socialnetwork.gui.handlers;
import hu.bme.mit.socialnetwork.gui.ListView;

import java.io.IOException;
import java.util.Collections;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.IHandler;
import org.eclipse.core.resources.IFile;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IViewPart;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.handlers.HandlerUtil;

import socialnetwork.SocialNetwork;


public class OpenViewFromFile extends AbstractHandler implements IHandler {

	@Override
	public Object execute(ExecutionEvent event) throws ExecutionException {
		try {
			ISelection selection = HandlerUtil.getCurrentSelection(event);
			Object _sel = ((IStructuredSelection)selection).getFirstElement();
			if (!(_sel instanceof IFile)) return null;
			
			IFile file = (IFile) _sel;
			ResourceSet set = new ResourceSetImpl();
			Resource res = set.getResource(URI.createPlatformResourceURI(
					file.getFullPath().toString(), true),
					true);
			res.load(Collections.EMPTY_MAP);
			
			IViewPart part = PlatformUI.getWorkbench()
					.getActiveWorkbenchWindow().getActivePage()
					.showView("hu.bme.mit.socialnetwork.gui.networkview");
			ListView view = (ListView) part;
			view.setNetwork((SocialNetwork) res.getContents().get(0));
		} catch (PartInitException e) {
			throw new ExecutionException("Cannot open view", e);
		} catch (ClassCastException e) {
			throw new ExecutionException("Invalid EMF model", e);
		} catch (IOException e) {
			throw new ExecutionException("Cannot load EMF model", e);
		} catch (Exception e) {
			throw new ExecutionException("Cannot load EMF model", e);
		}
		return null;
	}

}
